<?php
/**
 * Copyright © 2016 Filoblu S.r.l. All rights reserved.
 */

namespace FiloBlu\OrderAdditionalData\Model;

use FiloBlu\OrderAdditionalData\Api\OrderDataInterface;
use Magento\Framework\App\ObjectManager;
use Magento\Framework\Model\AbstractModel;
use Magento\Framework\Serialize\SerializerInterface;
use function unserialize;

/**
 * OAD Order Additional Data
 */
class OrderData extends AbstractModel implements OrderDataInterface
{
    /**
     * @return mixed
     * Return additional data
     *
     */
    public function getDataArray()
    {
        if (interface_exists(SerializerInterface::class) || class_exists(SerializerInterface::class)) {
            return ObjectManager::getInstance()->create(SerializerInterface::class)
                ->unserialize($this->getAdditionalData());
        }

        return unserialize($this->getAdditionalData());
    }

    protected function _construct()
    {
        $this->_init(ResourceModel\OrderData::class);
    }
}
